/// <reference path="../web/jquery/jquery.d.ts" />
/// <reference path="sShare.ts" />
var device;
var ip = "0.0.0.0";
var clockId = "0";
var rememberPasswordEnabled = false;
var isCompanys = false;
var isDepartments = false;
var isTimeZones = false;
var sUrl = ""; //= window.localStorage.getItem("sUrl");
var native = "";
function btnLogin_click() {
    var user = $("#txtUserName").val().trim();
    var password = $("#txtPassword").val().trim();
    var selRemeber = 0;
    if ($("#cbxRememberPassword").prop('checked'))
        selRemeber = 1;
    if ((user == 'username') || (user == "") || (password == "password") || (password == "")) {
        alert("Please input username and password.");
        return;
    }
    var loginClass = $("#btnLogin").attr("class");
    if (loginClass.indexOf("disabled") > 0)
        return;
    $("#imgRefresh").show();
    $("#btnLogin").html("loading ...");
    $("#btnLogin").addClass("disabled");
    $.post(sUrl + "back/sLogin.php", { "userName": user, "Password": password, "selRemeber": selRemeber, "clockId": clockId }, function (data) {
        var ac = JSON.parse(data);
        $("#imgRefresh").hide();
        if (ac == 'NOTMATCHING') {
            $("#btnLogin").removeClass("disabled");
            $("#btnLogin").html("Login");
            alert("Username or password not matching.");
            return;
        }
        if (ac[0]['RememberPasswordEnabled'] == '1')
            rememberPasswordEnabled = true;
        if (rememberPasswordEnabled && ($("#cbxRememberPassword").prop('checked'))) {
            window.localStorage.setItem("user", user);
            window.localStorage.setItem("password", password);
            window.localStorage.setItem('rememberPassword', "checked");
        }
        else {
            $("#txtUserName").val("");
            $("#txtPassword").val("");
        }
        setvalue('acUser', ac);
        getCompanys();
        getTimeZones();
        getDepartments();
    });
}
function getCompanys() {
    $.post(sUrl + "back/sGetCompanys.php", { "userName": $("#txtUserName").val(), "Password": $("#txtPassword").val() }, function (data) {
        data = JSON.parse(data);
        setvalue('acCompanys', data);
        isCompanys = true;
        if (getvalue('acUser')[0]['Role'] == 'Employee') {
            jump();
        }
        else if (getvalue('acUser')[0]['Role'] == 'Manager') {
            if (isDepartments && isTimeZones) {
                jump();
            }
        }
    });
}
function getDepartments() {
    $.post(sUrl + "back/sGetDepartments.php", { "userName": $("#txtUserName").val(), "Password": $("#txtPassword").val() }, function (data) {
        data = JSON.parse(data);
        setvalue('acDepartments', data);
        isDepartments = true;
        if (isCompanys && isTimeZones) {
            jump();
        }
    });
}
function getTimeZones() {
    $.post(sUrl + "back/sGetTimeZones.php", {}, function (data) {
        data = JSON.parse(data);
        setvalue('acTimeZones', data);
        isTimeZones = true;
        if (isCompanys && isDepartments) {
            jump();
        }
    });
}
function jump() {
    window.location.href = 'sClock.html';
}
function getCookieInfo() {
    if (window.localStorage.getItem("user") != "" && window.localStorage.getItem("user") != null && window.localStorage.getItem("password") != "" && window.localStorage.getItem("password") != null) {
        window.localStorage.setItem("rememberPassword", "checked");
        $("#cbxRememberPassword").prop("checked", true);
        if (window.localStorage.getItem('user') != null && window.localStorage.getItem('user') != "") {
            $("#txtUserName").val(window.localStorage.getItem('user'));
            $("#txtUserName").css("color", "#000000");
        }
        if (window.localStorage.getItem('password') != null && window.localStorage.getItem('password') != "") {
            $("#txtPassword").val(window.localStorage.getItem('password'));
            $("#txtPassword").css("color", "#000000");
        }
        if (Request.parameter('logout') != 'true' && Request.parameter('logout') != 'true#')
            btnLogin_click();
    }
    else {
        window.localStorage.setItem("rememberPassword", "");
        $("#cbxRememberPassword").prop("checked", false);
        $("#txtUserName").val("");
        $("#txtPassword").val("");
    }
}
function getClockId() {
    var deviceId = "";
    if (native.indexOf("http") == -1) {
        deviceId = device.uuid;
    }
    $.post(sUrl + "back/sGetClockId.php", { "deviceId": deviceId }, function (data) {
        clockId = JSON.parse(data);
        window.localStorage.setItem("clockID", clockId);
        $("#lblClockId").html(clockId);
        getCookieInfo();
    });
}
function init() {
    window.localStorage.setItem('sUrl', 'https://www.timeclockfree.com/mobile/'); //
    sUrl = window.localStorage.getItem('sUrl');
    sessionStorage.clear();
    getIp();
    /*
    if (Request.parameter('clockID') != 'undefined' && Request.parameter('clockID') != undefined)
        window.localStorage.setItem('clockID', Request.parameter('clockID'));
    */
    if (window.localStorage.getItem('clockID') != null && window.localStorage.getItem('clockID') != 'null' && window.localStorage.getItem('clockID') != "" && window.localStorage.getItem('clockID') != 'undefined') {
        clockId = window.localStorage.getItem('clockID');
        $("#lblClockId").html(clockId);
        getCookieInfo();
    }
    else
        getClockId();
}
function getIp() {
    $.post(sUrl + "back/sGetIp.php", "", function (data) {
        ip = JSON.parse(data);
        $("#lblIp").html(ip);
    });
}
function txtUser_focusin() {
    var user = $("#txtUserName").attr('placeholder'); //$("#txtUserName").val().trim();
    if (user == 'username' && $("#txtUserName").val() == "") {
        $("#txtUserName").val("");
        $("#txtUserName").attr('placeholder', "");
        $("#txtUserName").css("color", "#000000");
    }
    else
        setTimeout(function () { $("#txtUserName").select(); }, 100);
}
function txtUser_focusout() {
    var user = $("#txtUserName").val().trim();
    if (user == "") {
        $("#txtUserName").attr('placeholder', "username");
        $("#txtUserName").css("color", "#CCCCCC");
    }
}
function txtPassword_focusin() {
    var password = $("#txtPassword").attr('placeholder');
    if (password == "password") {
        $("#txtPassword").attr('placeholder', "");
        $("#txtPassword").css("color", "#000000");
    }
}
function txtPassword_focusout() {
    var password = $("#txtPassword").val().trim();
    if (password == "") {
        $("#txtPassword").attr('placeholder', "password");
        $("#txtPassword").css("color", "#CCCCCC");
    }
}
function cbxRememberPassword_change() {
    var user = $("#txtUserName").val().trim();
    var password = $("#txtPassword").val().trim();
    if ($("#cbxRememberPassword").prop('checked') != true) {
        window.localStorage.setItem("user", "");
        window.localStorage.setItem("password", "");
        window.localStorage.setItem("rememberPassword", "");
    }
    else {
        window.localStorage.setItem("user", user);
        window.localStorage.setItem("password", password);
        window.localStorage.setItem("rememberPassword", "checked");
    }
}
function lnkBigScreen_click() {
    if (native.indexOf("http") == -1) {
        cordova.InAppBrowser.open('https://www.opentimeclock.com/free.html', '_system', 'location=yes');
    }
    else {
        window.location.href = 'https://www.opentimeclock.com/free.html';
    }
}
function lnkExitapp_click() {
    if (native.indexOf("http") == -1) {
        if (navigator.userAgent.match(/Windows/i))
            window.close();
        else
            navigator.app.exitApp();
    }
}
function lnkButton_click() {
    var action = $(this).val();
    if (action == "barcode")
        window.location.href = 'barcode.html';
    else if (action == "big web")
        lnkBigScreen_click();
    else if (action == "help")
        window.location.href = "contact-us.html";
    else {
        lnkExitapp_click();
    }
}
function imgRefresh_click() {
    $("#btnLogin").removeClass("disabled");
    $("#btnLogin").html("Login");
}
$(function () {
    native = window.location.toString();
    if (native.indexOf("http") == -1) {
        $("#divExitApp").show();
        var u = navigator.userAgent;
        if (u.indexOf('iPhone') > -1) {
            $("#divExitApp").hide();
        }
        document.addEventListener('deviceready', init, false);
    }
    else {
        var url = window.location.href;
        url = url.substr(0, 20);
        if (url == "https://timeclockfre" || url == "http://timeclockfree" || url == "http://www.timeclock") {
            window.location.href = "https://www.timeclockfree.com/mobile/index.html";
            return;
        }
        $("#divExitApp").hide();
        init();
    }
    $("#txtUserName").focusin(txtUser_focusin);
    $("#txtUserName").focusout(txtUser_focusout);
    $("#txtPassword").focusin(txtPassword_focusin);
    $("#txtPassword").focusout(txtPassword_focusout);
    $("#cbxRememberPassword").change(cbxRememberPassword_change);
    $("#btnLogin").click(btnLogin_click);
    $("#divBarcodeFoot").on("click", "button", lnkButton_click);
    $("#imgRefresh").click(imgRefresh_click);
});
//# sourceMappingURL=index.js.map