function setvalue(name, value) {
    sessionStorage.setItem(name, JSON.stringify(value));
}
function getvalue(name) {
    return JSON.parse(sessionStorage.getItem(name));
}
function string2date(sdatetime) {
    var aDateTime = sdatetime.split(' ');
    var sdate = aDateTime[0];
    var stime = aDateTime[1];
    var date = sdate.split('-');
    var year = Number(date[0]);
    var month = Number(date[1]);
    var day = Number(date[2]);
    var time = stime.split(':');
    var hour = Number(time[0]);
    var minute = Number(time[1]);
    var second = Number(time[2]);
    var dDateTime = new Date();
    dDateTime.setFullYear(year, month - 1, day);
    dDateTime.setHours(hour, minute, second, 0);
    return dDateTime;
}
function notes(note) {
    note = note.replace("<", '(');
    note = note.replace("<", '(');
    note = note.replace("<", '(');
    note = note.replace("<", '(');
    note = note.replace("<", '(');
    note = note.replace("<", '(');
    note = note.replace("<", '(');
    note = note.replace("<", '(');
    note = note.replace("<", '(');
    note = note.replace("<", '(');
    note = note.replace(">", ')');
    note = note.replace(">", ')');
    note = note.replace(">", ')');
    note = note.replace(">", ')');
    note = note.replace(">", ')');
    note = note.replace(">", ')');
    note = note.replace(">", ')');
    note = note.replace(">", ')');
    note = note.replace(">", ')');
    note = note.replace(">", ')');
    return note;
}
function date2string(dDateTime) {
    var year = dDateTime.getFullYear();
    var month = dDateTime.getMonth() + 1;
    var date = dDateTime.getDate();
    var hour = dDateTime.getHours();
    var minute = dDateTime.getMinutes();
    var second = dDateTime.getSeconds();
    var sYear = year.toString();
    var sMonth = month.toString();
    if (month < 10)
        sMonth = "0" + sMonth;
    var sDate = date.toString();
    if (date < 10)
        sDate = "0" + sDate;
    var sHour = hour.toString();
    if (hour < 10)
        sHour = "0" + sHour;
    var sMinute = minute.toString();
    if (minute < 10)
        sMinute = "0" + sMinute;
    var sSecond = second.toString();
    if (second < 10)
        sSecond = "0" + sSecond;
    var sDateTime = sYear + "-" + sMonth + "-" + sDate + " " + sHour + ":" + sMinute + ":" + sSecond;
    return sDateTime;
}
function string2weekday(sdatetime) {
    //alert('30=' + sdatetime);
    var d = string2date(sdatetime);
    var weekDay = d.getDay();
    //alert("27="+weekDay.toString());
    if (weekDay == 0) {
        return "Sun";
    }
    else if (weekDay == 1) {
        return "Mon";
    }
    else if (weekDay == 2) {
        return "Tue";
    }
    else if (weekDay == 3) {
        return "Wed";
    }
    else if (weekDay == 4) {
        return "Thu";
    }
    else if (weekDay == 5) {
        return "Fri";
    }
    else if (weekDay == 6) {
        return "Sat";
    }
}
function getDate(sDate) {
    var oMonth = sDate.getMonth() + 1;
    var oDateDay = sDate.getDate();
    var oYear = sDate.getFullYear().toString();
    var sMonthDay = oMonth.toString();
    var sNewDateDay = oDateDay.toString();
    if (oMonth < 10)
        sMonthDay = "0" + sMonthDay;
    if (oDateDay < 10)
        sNewDateDay = "0" + sNewDateDay;
    return sMonthDay + "/" + sNewDateDay + "/" + oYear;
}
function formatIOTime(sdatetime) {
    var weekday = string2weekday(sdatetime);
    var date = sdatetime.substr(5, 2) + "/" + sdatetime.substr(8, 2); // + "/" + sdatetime.substr(0, 4);
    var InDateTime = sdatetime.substr(11, 5);
    var Hours = string2hours(InDateTime.substr(0, 2));
    var Minute = InDateTime.substr(3, 2);
    var ap = hours2ampm(InDateTime.substr(0, 2));
    var hourminute = Hours + ":" + Minute + " " + ap;
    return weekday + " " + date + " " + hourminute;
}
function formatAMPM(date) {
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var ampm = hours >= 12 ? 'PM' : 'AM';
    hours = hours % 12;
    hours = hours ? hours : 12; // the hour '0' should be '12'
    hours = hours < 10 ? '0' + hours : hours;
    minutes = minutes < 10 ? '0' + minutes : minutes;
    seconds = seconds < 10 ? '0' + seconds : seconds;
    var sTime = hours + ':' + minutes + ':' + seconds + ' ' + ampm;
    return sTime;
}
function format24(date) {
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    hours = hours < 10 ? '0' + hours : hours;
    minutes = minutes < 10 ? '0' + minutes : minutes;
    seconds = seconds < 10 ? '0' + seconds : seconds;
    var sTime = hours + ':' + minutes + ':' + seconds;
    return sTime;
}
function hours2ampm(number) {
    if (number >= 12) {
        number = "pm";
    }
    else {
        number = "am";
    }
    return number;
}
function hoursAMPM(number) {
    if (number >= 12) {
        number = "PM";
    }
    else {
        number = "AM";
    }
    return number;
}
function string2hours(hrs) {
    if (hrs == "00") {
        hrs = "12";
    }
    hrs = parseInt(hrs, 10);
    if (hrs > 12) {
        hrs = hrs - 12;
    }
    if (hrs < 10) {
        hrs = "0" + hrs;
    }
    return hrs;
}
function getDateFormart(datetime, format) {
    var now = string2date(datetime); //new Date(datetime);
    var month = now.getMonth() + 1;
    var date = now.getDate();
    var sYear = now.getFullYear().toString();
    var sMonth = month.toString();
    var sDate = date.toString();
    var newDate = "";
    if (month < 10)
        sMonth = "0" + sMonth;
    if (date < 10)
        sDate = "0" + sDate;
    if (format == "0")
        newDate = sMonth + "/" + sDate + "/" + sYear;
    else if (format == "1")
        newDate = sYear + "-" + sMonth + "-" + sDate;
    else if (format == "2")
        newDate = sDate + "/" + sMonth + "/" + sYear;
    return newDate;
}
function getTimeTotalsFormat(timeTotal) {
    var timeHours = "";
    var arr = timeTotal.split(".");
    if (getvalue("acCompanys")[0].TimeTotalsFormat == "0") {
        var hrs = "";
        if (parseInt(arr[0]) < 10) {
            hrs = "0" + arr[0];
        }
        else {
            hrs = arr[0];
        }
        if (arr[1] == "" || arr[1] == null) {
            timeHours = hrs + ":00";
        }
        else {
            var min = Math.round(parseFloat("0." + arr[1]) * 60);
            if (min < 10) {
                timeHours = hrs + ":0" + min;
            }
            else if (min == 60) {
                timeHours = (parseFloat(hrs) + 1) + ":00";
            }
            else {
                timeHours = hrs + ":" + min;
            }
        }
    }
    else if (getvalue("acCompanys")[0].TimeTotalsFormat == "1") {
        var hrs = arr[0];
        if (arr[1] == "" || arr[1] == null) {
            timeHours = hrs + "h 0m";
        }
        else {
            var min = Math.round(parseFloat("0." + arr[1]) * 60);
            if (min == 60) {
                timeHours = (parseFloat(hrs) + 1) + "h 0m";
            }
            else {
                timeHours = hrs + "h " + min + "m";
            }
        }
    }
    else if (getvalue("acCompanys")[0].TimeTotalsFormat == "2") {
        timeHours = Number(timeTotal).toFixed(2);
    }
    else if (getvalue("acCompanys")[0].TimeTotalsFormat == "3") {
        timeHours = Number(timeTotal).toFixed(3);
    }
    return timeHours;
}
function getReportDateFormat(sDate, temp) {
    if (temp == "0") {
        if (getvalue("acCompanys")[0].DateFormat == "0") {
            sDate = sDate;
        }
        else if (getvalue("acCompanys")[0].DateFormat == "1") {
            sDate = sDate.substr(5, 2) + "/" + sDate.substr(8, 2) + "/" + sDate.substr(0, 4);
        }
        else if (getvalue("acCompanys")[0].DateFormat == "2") {
            sDate = sDate.substr(3, 2) + "/" + sDate.substr(0, 2) + "/" + sDate.substr(6, 4);
        }
    }
    else if (temp == "1") {
        if (getvalue("acCompanys")[0].DateFormat == "0") {
            sDate = sDate.substr(6, 4) + "-" + sDate.substr(0, 2) + "-" + sDate.substr(3, 2);
        }
        else if (getvalue("acCompanys")[0].DateFormat == "1") {
            sDate = sDate; // sDate.substr(6, 4) + "-" + sDate.substr(3, 2) + "-" + sDate.substr(0, 2);
        }
        else {
            sDate = sDate.substr(6, 4) + "-" + sDate.substr(3, 2) + "-" + sDate.substr(0, 2);
        }
    }
    return sDate;
}
function ampm2time(ampm) {
    var hour = ampm.substr(0, 2);
    var minute = ampm.substr(3, 2);
    var ampm = ampm.substr(6, 2);
    if (ampm.toUpperCase() == "AM") {
        if (hour == "12")
            hour = "00";
    }
    else if (ampm.toUpperCase() == "PM") {
        if (hour != "12") {
            var iHour = (Number(hour) + 12);
            if (iHour < 10)
                hour = "0" + iHour.toString();
            else
                hour = iHour.toString();
        }
    }
    var time = hour + ":" + minute + ":00";
    return time;
}
function get24Time(dateTime) {
    var arr = dateTime.split(" ");
    var arr1 = arr[0].split(":");
    var hours = arr1[0];
    var min = arr1[1];
    if (parseFloat(hours) == 12)
        hours = (parseFloat(hours) - 12).toString();
    if (arr[1] == "PM")
        hours = (parseFloat(hours) + 12).toString();
    return hours + ":" + min;
}
function time2ampm(time) {
    var iHour = Number(time.substr(0, 2));
    var minute = time.substr(3, 2);
    var hour = "";
    var ampm = "";
    if (iHour == 0)
        ampm = "12:" + minute + " AM";
    else if ((iHour > 0) && (iHour < 10)) {
        ampm = "0" + iHour.toString() + ":" + minute + " AM";
    }
    else if ((iHour == 10) || (iHour == 11)) {
        ampm = iHour.toString() + ":" + minute + " AM";
    }
    else if (iHour == 12) {
        ampm = "12:" + minute + " PM";
    }
    else if ((iHour > 12) && (iHour < 22)) {
        ampm = "0" + (iHour - 12).toString() + ":" + minute + " PM";
    }
    else if ((iHour == 22) || (iHour == 23)) {
        ampm = (iHour - 12).toString() + ":" + minute + " PM";
    }
    return ampm;
}
var Request = {
    parameter: function (name) {
        return decodeURI(this.parameters()[name]);
    },
    parameters: function () {
        var result = {};
        var url = window.location.href;
        var parameters = url.slice(url.indexOf('?') + 1).split('&');
        for (var i = 0; i < parameters.length; i++) {
            var parameter = parameters[i].split('=');
            result[parameter[0]] = decodeURI(parameter[1]);
        }
        return result;
    },
    pageName: function () {
        var page = window.location.href;
        page = page.substring(page.lastIndexOf("/") + 1, page.indexOf(".html"));
        return page;
    }
};
function isEmail(email) {
    var regex = /^([a-zA-Z0-9_\.\-\+])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
    return regex.test(email);
}
//# sourceMappingURL=sShare.js.map