﻿
function setvalue(name:string,value:any):any { 
    sessionStorage.setItem(name, JSON.stringify(value));
}

function getvalue(name:string):any { 
    return JSON.parse(sessionStorage.getItem(name));
}

function string2date(sdatetime: string): Date { //2012-12-24 10:50:50
    var aDateTime: string[] = sdatetime.split(' '); 
    var sdate: string = aDateTime[0]; 
    var stime: string = aDateTime[1]; 

    var date: string[] = sdate.split('-'); 
    var year: number = Number(date[0]); 
    var month: number = Number(date[1]); 
    var day: number = Number(date[2]); 

    var time: string[] = stime.split(':'); 
    var hour: number = Number(time[0]); 
    var minute: number = Number(time[1]); 
    var second: number = Number(time[2]); 

    var dDateTime: Date = new Date(); 
    dDateTime.setFullYear(year, month - 1, day); 
    dDateTime.setHours(hour, minute, second, 0); 
    return dDateTime;
}

function notes(note: string): string { 
    note = note.replace("<",'(');
    note = note.replace("<",'(');
    note = note.replace("<",'(');
    note = note.replace("<",'(');
    note = note.replace("<",'(');
    note = note.replace("<",'(');
    note = note.replace("<",'(');
    note = note.replace("<",'(');
    note = note.replace("<",'(');
    note = note.replace("<",'(');
    note = note.replace(">",')');
    note = note.replace(">",')');
    note = note.replace(">",')');
    note = note.replace(">",')');
    note = note.replace(">",')');
    note = note.replace(">",')');
    note = note.replace(">",')');
    note = note.replace(">",')');
    note = note.replace(">",')');
    note = note.replace(">",')');
    return note;
}

function date2string(dDateTime: Date): string { 
    var year: number = dDateTime.getFullYear();
    var month: number = dDateTime.getMonth() + 1;
    var date: number = dDateTime.getDate();
    var hour: number = dDateTime.getHours();
    var minute: number = dDateTime.getMinutes();
    var second: number = dDateTime.getSeconds();
    var sYear: string = year.toString();
    var sMonth: string = month.toString();
    if(month<10)
        sMonth = "0" + sMonth;
    var sDate: string = date.toString();
    if(date<10)
        sDate = "0" + sDate;
    var sHour: string = hour.toString();
    if(hour<10)
        sHour = "0" + sHour;
    var sMinute: string = minute.toString();
    if(minute<10)
        sMinute = "0" + sMinute;
    var sSecond: string = second.toString();
    if(second<10)
        sSecond = "0" + sSecond;

    var sDateTime: string = sYear + "-" + sMonth + "-" + sDate  + " " + sHour + ":" + sMinute + ":" + sSecond;
    return sDateTime;
}

function string2weekday(sdatetime: string):string {
    //alert('30=' + sdatetime);
    var d = string2date(sdatetime);
    var weekDay = d.getDay();
    //alert("27="+weekDay.toString());
    if (weekDay == 0) {
        return "Sun";
    } else if (weekDay == 1) {
        return "Mon";
    } else if (weekDay == 2) {
        return "Tue";
    } else if (weekDay == 3) {
        return "Wed";
    } else if (weekDay == 4) {
        return "Thu";
    } else if (weekDay == 5) {
        return "Fri";
    } else if (weekDay == 6) {
        return "Sat";
    }
}


function getDate(sDate:Date) { //得到相应的日期格式XX/XX/XXXX
    var oMonth:number=sDate.getMonth()+1;
    var oDateDay:number=sDate.getDate();
    var oYear:string=sDate.getFullYear().toString();
    var sMonthDay:string=oMonth.toString();
    var sNewDateDay:string=oDateDay.toString();
    if(oMonth<10)
        sMonthDay = "0" + sMonthDay;
    if(oDateDay<10)
        sNewDateDay = "0" + sNewDateDay;
    return sMonthDay + "/" + sNewDateDay + "/" + oYear;

}


function formatIOTime(sdatetime:string):string {
    var weekday = string2weekday(sdatetime);
    var date = sdatetime.substr(5, 2) + "/" + sdatetime.substr(8, 2);// + "/" + sdatetime.substr(0, 4);

    var InDateTime = sdatetime.substr(11, 5);
    var Hours = string2hours(InDateTime.substr(0, 2));
    var Minute = InDateTime.substr(3, 2);
    var ap = hours2ampm(InDateTime.substr(0, 2));
    var hourminute = Hours + ":" + Minute + " " + ap;
    return weekday + " " + date + " " + hourminute;
}

function formatAMPM(date:Date):string {
  var hours:any = date.getHours();
  var minutes:any = date.getMinutes();
  var seconds:any = date.getSeconds();
  var ampm = hours >= 12 ? 'PM' : 'AM';
  hours = hours % 12;
  hours = hours ? hours : 12; // the hour '0' should be '12'
  hours = hours < 10 ? '0'+hours : hours;
  minutes = minutes < 10 ? '0'+minutes : minutes;
  seconds = seconds < 10 ? '0'+seconds : seconds;
  var sTime:string = hours + ':' + minutes +':'+seconds+ ' ' + ampm;
  return sTime;
}

function format24(date: Date): string { 
    var hours:any = date.getHours();
    var minutes:any = date.getMinutes();
    var seconds:any = date.getSeconds();
    hours = hours < 10 ? '0'+hours : hours;
    minutes = minutes < 10 ? '0'+minutes : minutes;
    seconds = seconds < 10 ? '0'+seconds : seconds;
    var sTime:string = hours + ':' + minutes +':'+seconds;
    return sTime;
}

function hours2ampm(number)                                    
{
    if (number >= 12) {
        number = "pm";
    }
    else {
        number = "am";
    }
    return number;
}
function hoursAMPM(number)                                    
{
    if (number >= 12) {
        number = "PM";
    }
    else {
        number = "AM";
    }
    return number;
}

function string2hours(hrs) {  
    if (hrs == "00") {
        hrs = "12";
    }
    hrs = parseInt(hrs, 10);
    if (hrs > 12) {
        hrs = hrs - 12;
    }
    if (hrs < 10) { 
        hrs = "0" + hrs;
    }
    return hrs;
}

function getDateFormart(datetime:string,format:string):string { 
    var now: Date = string2date(datetime); //new Date(datetime);
    var month: number = now.getMonth() + 1;
    var date: number = now.getDate();
    var sYear: string = now.getFullYear().toString();
    var sMonth: string = month.toString();
    var sDate: string = date.toString();
    var newDate: string = "";
    if (month < 10)
        sMonth = "0" + sMonth;
    if (date < 10)
        sDate = "0" + sDate;
    if (format == "0") 
        newDate=sMonth + "/" + sDate + "/" + sYear;
    else if (format=="1") 
        newDate = sYear + "-" + sMonth + "-" + sDate;
    else if(format=="2")
        newDate = sDate + "/" + sMonth + "/" + sYear;
    return newDate;
}

function getTimeTotalsFormat(timeTotal:string) :string{ 
    var timeHours: string = "";
    var arr = timeTotal.split(".");
    
    if (getvalue("acCompanys")[0].TimeTotalsFormat == "0") { 
        var hrs = "";
        if (parseInt(arr[0]) < 10) {
            hrs = "0" + arr[0];
        } else { 
            hrs = arr[0];
        }
        if (arr[1] == "" || arr[1] == null) {
            timeHours = hrs + ":00";
        } else { 
            var min = Math.round(parseFloat("0."+arr[1]) * 60);
            if (min < 10) {
                timeHours = hrs + ":0" + min;
            } else if (min == 60) { 
                timeHours = (parseFloat(hrs)+1) + ":00";
            } else {
                timeHours = hrs + ":" + min;
            }
        }
    }else if (getvalue("acCompanys")[0].TimeTotalsFormat == "1") { 
        var hrs = arr[0];
        if (arr[1] == "" || arr[1] == null) {
            timeHours = hrs + "h 0m";
        } else { 
            var min = Math.round(parseFloat("0."+arr[1]) * 60);
            if (min == 60) {
                timeHours = (parseFloat(hrs) + 1) + "h 0m"
            } else {
                timeHours = hrs + "h " + min + "m";
            }
        }
    
    }else if (getvalue("acCompanys")[0].TimeTotalsFormat == "2") { 
        timeHours = Number(timeTotal).toFixed(2);
    }else if (getvalue("acCompanys")[0].TimeTotalsFormat == "3") { 
        timeHours = Number(timeTotal).toFixed(3);
    }
    return timeHours;
}

function getReportDateFormat(sDate:string,temp:string) { 
    if (temp == "0") { 
        if (getvalue("acCompanys")[0].DateFormat == "0") { 
            sDate = sDate;
        }else if (getvalue("acCompanys")[0].DateFormat == "1") { 
            sDate = sDate.substr(5, 2) + "/" + sDate.substr(8, 2) + "/" + sDate.substr(0, 4);
        } else if (getvalue("acCompanys")[0].DateFormat == "2") { 
            sDate = sDate.substr(3, 2) + "/" + sDate.substr(0, 2) + "/" + sDate.substr(6, 4);
        }
    }else if (temp == "1") {
        if (getvalue("acCompanys")[0].DateFormat == "0") {
            sDate = sDate.substr(6, 4) + "-" + sDate.substr(0, 2) + "-" + sDate.substr(3, 2);
        } else if (getvalue("acCompanys")[0].DateFormat == "1") {
            sDate = sDate;// sDate.substr(6, 4) + "-" + sDate.substr(3, 2) + "-" + sDate.substr(0, 2);
        } else {
            sDate = sDate.substr(6, 4) + "-" + sDate.substr(3, 2) + "-" + sDate.substr(0, 2);
        }
    }
    return sDate;
}


function ampm2time(ampm: string):string { //00:00 AM => 00:00:00
    var hour: string = ampm.substr(0, 2);
    var minute: string = ampm.substr(3, 2);
    var ampm: string = ampm.substr(6, 2);

    if (ampm.toUpperCase() == "AM") {
        if (hour == "12")
            hour = "00";
    } else if (ampm.toUpperCase() == "PM") { 
        if (hour != "12") {
            var iHour:number = (Number(hour)+12);
            if(iHour<10)
                hour = "0" + iHour.toString();
            else
                hour = iHour.toString();
        }
    }
    var time: string = hour + ":" + minute + ":00";
    return time;
}

function get24Time(dateTime: string): string { 
    var arr = dateTime.split(" "); 
    var arr1 = arr[0].split(":");
    var hours: string = arr1[0];
    var min: string = arr1[1]; 
    if(parseFloat(hours)==12)
        hours = (parseFloat(hours)-12).toString();
    if (arr[1] == "PM") 
        hours = (parseFloat(hours) + 12).toString();
    return hours+":"+min;
}

function time2ampm(time: string):string { //00:00 => 00:00 AM
    var iHour: number = Number(time.substr(0, 2));
    var minute: string = time.substr(3, 2);
    var hour: string = "";
    var ampm: string = "";

    if(iHour==0)
        ampm = "12:"+minute+" AM";
    else if ((iHour > 0) && (iHour < 10)) {
        ampm = "0"+ iHour.toString() + ":" + minute + " AM";
    }else if ((iHour == 10) || (iHour == 11)) {
        ampm = iHour.toString() + ":" + minute + " AM";
    }else if (iHour == 12) {
        ampm = "12:" + minute + " PM";
    }else if ((iHour > 12)&&(iHour < 22)) {
        ampm = "0"+(iHour-12).toString()+ ":" + minute + " PM";
    }else if ((iHour ==22)||(iHour == 23)) {
        ampm = (iHour-12).toString()+ ":" + minute + " PM";
    }

    return ampm;
}

var Request = {	
 	parameter: function(name) {
 		return decodeURI(this.parameters()[name]);
 	},
 	
 	parameters: function() {
 		var result = {};
 		var url = window.location.href;
 		var parameters = url.slice(url.indexOf('?') + 1).split('&');
 		
 		for(var i = 0;  i < parameters.length; i++) {
 			var parameter = parameters[i].split('=');
 			result[parameter[0]] = decodeURI(parameter[1]);
 		}
 		return result;
 	},

    pageName: function() { 
        var page: string = window.location.href;
        page = page.substring(page.lastIndexOf("/") + 1,page.indexOf(".html"));
        return page;
    }
 }

 function isEmail(email) {
  var regex = /^([a-zA-Z0-9_\.\-\+])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
  return regex.test(email);
}
