/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

var pictureSource;  //趨ͼƬԴ
var destinationType; //ѡ񷵻ݵĸʽ

function onPhotoDataSuccess(imageData) {
    // base64 encoded image data
    var smallImage = document.getElementById('smallImage');

    smallImage.style.display = 'block';
    //ʹbase64ʱҪʹǰ׺
    smallImage.src = "data:image/jpeg;base64," + imageData;
}

function onFail(message) {
    alert('Failed because: ' + message);
}

function capturePhoto() {
    
    navigator.camera.getPicture(onPhotoDataSuccess, onFail, {
        quality: 100,
        destinationType: destinationType.DATA_URL,
        cameraDirection: Camera.Direction.FRONT,
        //cameraDirection: Camera.Direction.BACK,
        targetWidth: 280,
        targetHeight: 210,
        saveToPhotoAlbum: false,
        correctOrientation: true
    });
}

function go() {
    //var ref = window.open('https://www.timeclockfree.com/mobile/?native=1', '_self', 'location=yes');
    //var ref = window.open('http://www.parktime.com/test/phonegap/index.html', '_self', 'location=yes');
    cordova.plugins.barcodeScanner.scan(
      function (result) {
          alert("We got a barcode\n" +
                "Result: " + result.text + "\n" +
                "Format: " + result.format + "\n" +
                "Cancelled: " + result.cancelled);
      },
      function (error) {
          alert("Scanning failed: " + error);
      }
   );
}

function browse() {
    // var ref = window.open('https://www.timeclockfree.com/phone/', '_blank', 'location=no,closebuttoncaption=return');
    var ref = window.open('http://www.parktime.com/test/test-close.html', '_blank', 'location=yes','closebuttoncaption=BACK');

   

    var loop = setInterval("close()", 500)
    function close() {
        var toclose = localStorage.getItem('toclose');
        if (toclose) {
            clearInterval(loop);
            ref.close();
        }
    }

    

}

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');

        pictureSource = navigator.camera.PictureSourceType;
        destinationType = navigator.camera.DestinationType;

    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        var parentElement = document.getElementById(id);
        /*var listeningElement = parentElement.querySelector('.listening');
        var receivedElement = parentElement.querySelector('.received');

        listeningElement.setAttribute('style', 'display:none;');
        receivedElement.setAttribute('style', 'display:block;');

        console.log('Received Event: ' + id);*/
    }
};
