﻿/// <reference path="../web/jquery/jquery.d.ts" />
/// <reference path="../web/bootstrap3.3.5/js/bootstrap-2.1.d.ts" />
/// <reference path="sShare.ts" />

interface JQuery {
    datetimepicker(option: any): JQuery;//in bootstrap-datepicker.js
}

var departmentId: number = -1;
var employeeId: number = getvalue("acUser")[0].ID;
var employeeName: string = getvalue("acUser")[0].Name;
var acOverview: ArrayConstructor;
var AutoLunchDeduction: number = 0;
var MinutesToDeduction: number = 0;
var AfterHowManyHours: number = 0;
var sUserName: string = getvalue('acUser')[0]['UserName'];
var sPassword: string = getvalue('acUser')[0]['Password'];
var sUrl: string = window.localStorage.getItem('sUrl');
var sIndex: number = -1;
var acTimeCards: ArrayConstructor;

class eOverview {
    static init() {
        $("#divOverView").html("loading ...");
        var txtDateFormart: string = "dd/mm/yyyy";
        if (getvalue("acCompanys")[0].DateFormat == "0")
            txtDateFormart = "mm/dd/yyyy";
        else if (getvalue("acCompanys")[0].DateFormat == "1")
            txtDateFormart = "yyyy-mm-dd";

        var html: string = "<div class='input-group date form_date' style='width:145px;float:left' data-date='' data-date-format='" + txtDateFormart + "' data-link-field='dtp_input2' data-link-format='" + txtDateFormart + "'>" +
            "<input id='txtStart' class='form-control' size='16' type='text' value=''>" +
            "<span class='input-group-addon'><span class='glyphicon glyphicon-calendar'></span></span>" +
            "</div>" +
            "<div class='input-group date form_date' style='width:145px;margin-left:155px;' data-date='' data-date-format='" + txtDateFormart + "' data-link-field='dtp_input2' data-link-format='" + txtDateFormart + "'>" +
            "<input id='txtEnd' class='form-control' size='16' type='text' value=''>" +
            "<span class='input-group-addon'><span class='glyphicon glyphicon-calendar'></span></span>" +
            "</div>";
        $("#divDateFormat").html(html);
        eOverview.initGetDateTime();
    }

    static getOverview() {
        $("#divOverView").html("loading ...");
        var sFrom = $("#txtStart").val();
        var sTo = $("#txtEnd").val();
        sFrom = getReportDateFormat(sFrom, "1");
        sTo = getReportDateFormat(sTo, "1");

        $.post(sUrl+"back/mGetOverViews.php", { "employeeId": employeeId, "departmentId": departmentId, "sFrom": sFrom, "sTo": sTo, "userName": sUserName, "Password": sPassword}, function (data) {
            var ac = JSON.parse(data);
            acTimeCards = eval(ac);
            var html: string = "";
            var sName = "-1";
            if (ac.length == 0)
                html += "<div style='margin-top:20px;margin-bottom:20px;margin-right:10px;margin-left:10px;'>no time entry in the selected date range.</div>";

            for (var i = 0; i < ac.length; i++) {
                AutoLunchDeduction = getvalue('acCompanys')[0].AutoLunchDeduction;
                if (AutoLunchDeduction == 2) {
                    AutoLunchDeduction = ac[i].AutoLunchDeduction;
                    MinutesToDeduction = ac[i].MinutesToDeduction;
                    AfterHowManyHours = ac[i].AfterHowManyHours;
                }

                var lblInTime: string = ac[i].InDateTime;
                var lblOutTime: string = ac[i].OutDateTime;
                if (ac[i]['Name'] != sName) {
                    if (sName != '-1') {
                        html += "</table></div>";
                    }
                    sName = ac[i]['Name'];
                    html += "<div style='background-color:#CDC5BF;margin-right:10px;font-size:20px;margin-left:10px;text-align:center;' class='span4'><span>&nbsp;</span></div>";
                    html += "<div style='margin-left:10px;margin-right:10px;'><table class='table table-striped'>";
                }
                html += "<tr><td index='"+i+"'><div style='width:30%;float:left;'>";
                var weekday: string = "";
                if (lblInTime != "0000-00-00 00:00:00") {
                    weekday = string2weekday(ac[i].InDateTime);
                    var sDate: string = (ac[i].FInDateTime).substr(0, 5);
                    if (getvalue("acCompanys")[0].DateFormat == "1") {
                        sDate = sDate.substr(0, 2) + "-" + sDate.substr(3, 2);
                    } else if (getvalue("acCompanys")[0].DateFormat == "2") {
                        sDate = sDate.substr(3, 2) + "/" + sDate.substr(0, 2);
                    }
                    html += sDate + ", " + weekday;
                } else {
                    weekday = string2weekday(ac[i].OutDateTime);
                    if (getvalue("acCompanys")[0].DateFormat == "1") {
                        sDate = ac.substr(0, 2) + "-" + ac.substr(3, 2);
                    } else if (getvalue("acCompanys")[0].DateFormat == "2") {
                        sDate = ac.substr(3, 2) + "-" + ac.substr(0, 2);
                    }
                    html += sDate + ", " + weekday;
                }
                html += "</div><div style='width:20%;float:left;'>";
                if ((lblInTime != null) && (lblInTime != undefined) && (lblInTime != "0000-00-00 00:00:00") && (lblInTime != "null")) {
                    var InDateTime = lblInTime.substr(11, 5);
                    if (getvalue("acCompanys")[0].TimeFormat == "0") {
                        var Hours = string2hours(InDateTime.substr(0, 2));
                        var Minute = InDateTime.substr(3, 2);
                        var ap = hours2ampm(InDateTime.substr(0, 2));
                        html += Hours + ":" + Minute + " " + ap;
                    } else {
                        html += InDateTime;
                    }
                } else {
                    html += "<span style='color:red;'>missing</span>";
                }
                html += "</div><div style='width:20%;float:left;'>";
                if ((lblOutTime != null) && (lblOutTime != undefined) && (lblOutTime != "0000-00-00 00:00:00") && (lblOutTime != "null")) {
                    var OutDateTime = lblOutTime.substr(11, 5);
                    if (getvalue("acCompanys")[0].TimeFormat == "0") {
                        var Hours = string2hours(OutDateTime.substr(0, 2));
                        var Minute = OutDateTime.substr(3, 2);
                        var ap = hours2ampm(OutDateTime.substr(0, 2));
                        html += Hours + ":" + Minute + " " + ap;
                    } else {
                        html += OutDateTime;
                    }
                } else
                    html += "<span style='color:red;'>missing</span>";
                html += "</div><div style='width:15%;float:left;'>";
                if (ac[i].HoursTime != null) {
                    var hours: number = Math.round(parseFloat(ac[i].HoursTime) * 100) / 100;
                    if (AutoLunchDeduction == 1) {
                        if (hours >= AfterHowManyHours) {
                            hours = hours - Math.round((MinutesToDeduction / 60) * 100) / 100;
                        }
                    }
                    if (hours < 0 || hours > 24) {
                        html += "&nbsp;";
                    } else {
                        html += getTimeTotalsFormat(hours.toString());
                    }
                }
                html += "</div><div style='width:15%;float:left;'>"+
                        "<a href='#' action='edit' style='text-decoration:underline'>note</a>"+
                        "</div>";
                if ((ac[i].EmployeeNotes != "" && ac[i].EmployeeNotes != null) || (ac[i].ManagerComments != "" && ac[i].ManagerComments != null)) {
                    html += "<div style='text-align:left;width:100%;margin-left:0px;float:left;'>";
                    html += eOverview.noteCommentEmployee(ac[i].EmployeeNotes, ac[i].ManagerComments, ac[i].LightComments, ac[i].ID, ac[i].Name);
                    html += "</div>";
                }
                html+="</td></tr>";
            }
            $("#divOverView").html(html);
        });
    }

    static noteCommentEmployee(note: string, comment: string, commentIsRead: string, timeCardId: string, userName: string): string {
        var comIsRead: boolean = false;
        if (commentIsRead == "1")
            comIsRead = true;
        var html: string = "";
        if (note != "" && note != null)
            html += "<div style='color:#aaaaaa;font-style:italic;'>&nbsp;&nbsp;&nbsp;&nbsp;<span style='font-weight:bold;'>" + userName + ": </span>" + note + "</div>";
        if ((!comIsRead) && comment != "" && comment != null)
            html += "<div onclick='eOverview.btnCloseManager_click(" + timeCardId + ");' style='color:#FA1212;background:#dff0d8;cursor:pointer;text-decoration:underline;'><span style='font-weight:bold;margin-left:20px;'>Manager: </span>" + comment + "</div>";
        else if (comment != "" && comment != null)
            html += "<div style='color:#aaaaaa;font-style:italic;'>&nbsp;&nbsp;&nbsp;&nbsp;<span style='font-weight:bold;'>Manager: </span>" + comment + "</div>";

        return html;
    }

    static btnCloseManager_click(timeCardId: string) {
        $.post(sUrl+"back/eCommentIsRead.php", { "timeCardId": timeCardId, "companyId": getvalue("acUser")[0].CompanyID }, function (data) {
            eOverview.getOverview();
        });
    }

    static initGetDateTime() {
        var today = new Date();
        var sToday = today.getFullYear() + "-" + (today.getMonth() + 1) + "-" + today.getDate() + " 23:59:59";
        var firstDayMilliseconds = today.getTime() - 1000 * 60 * 60 * 24 * 6;
        var firstDay = new Date();
        firstDay.setTime(firstDayMilliseconds);
        var sFirstDay = firstDay.getFullYear() + "-" + (firstDay.getMonth() + 1) + "-" + firstDay.getDate() + " 00:00:00";
        
        var yNowDate: string = getDateFormart(sFirstDay, getvalue("acCompanys")[0].DateFormat);
        var nowDate: string = getDateFormart(sToday, getvalue("acCompanys")[0].DateFormat);
        $("#txtStart").val(yNowDate);
        $("#txtEnd").val(nowDate);
        $('.form_date').datetimepicker({
            language: 'fr',
            weekStart: 1,
            todayBtn: 1,
            autoclose: 1,
            todayHighlight: 1,
            startView: 2,
            minView: 2,
            forceParse: 0
        });
        eOverview.getOverview();
    }
    
    static lnkEditComment_click() {
        sIndex = Number($(this).parent().parent().attr("index"));
        $("#dialogEditHead").html("edit note");
        $("#txtManagerComment").val(acTimeCards[sIndex].EmployeeNotes);
        $("#btnSave").html("Save");
        $("#btnSave").removeClass("disabled");
        $("#dialogEdit").modal("show");
    }

    static btnSave_click() {
        if ($("#btnSave").attr("disabled") == "disabled")
            return;
        var managerComment: string = $("#txtManagerComment").val().trim();
        managerComment = notes(managerComment);

        $("#btnSave").html("loading ...");
        $("#btnSave").addClass("disabled");
        $.post(sUrl+"back/mEditManagerComment.php", { "timeCardId": acTimeCards[sIndex].ID, "employeeId": employeeId, "managerComment": managerComment, "Role": getvalue("acUser")[0].Role, "companyId": getvalue("acUser")[0].CompanyID }, function (data) {
            $("#imgDone").show();
            setTimeout(function () {
                $("#dialogEdit").modal("hide");
                $("#imgDone").hide();
                $("#btnSave").removeClass("disabled");
                eOverview.getOverview();
            }, 500);
        });
    }
}


$(function () {

    eOverview.init();
    $("#txtStart").change(eOverview.getOverview);
    $("#txtEnd").change(eOverview.getOverview);

    $("#divOverView").on("click", "[action='edit']", eOverview.lnkEditComment_click);
    $("#btnSave").click(eOverview.btnSave_click);
});