/// <reference path="../web/jquery/jquery.d.ts" />
/// <reference path="sShare.ts" />
var sUserName = getvalue('acUser')[0]['UserName'];
var sPassword = getvalue('acUser')[0]['Password'];
var sUrl = window.localStorage.getItem('sUrl');
var mWhoisin = (function () {
    function mWhoisin() {
    }
    mWhoisin.init = function () {
        $("#tblWhoIsIn").html("loading ...");
        mWhoisin.getWhoisin();
    };
    mWhoisin.getWhoisin = function () {
        $.post(sUrl + "back/mGetWhoIsIn.php", { "userName": sUserName, "Password": sPassword }, function (data) {
            data = JSON.parse(data);
            if (data == null || data == "") {
                $("#tblWhoIsIn").html("There is no employee in selected department");
                return;
            }
            if (data.length == 0) {
                $("#tblWhoIsIn").html("There is no employee in your company. Please go to page [Setting]->[Employees] and click 'Add employee' button to add employees.");
            }
            else {
                var html = "";
                html += "<thead><tr><th>#</th><th>Name</th><th>Status</th></tr></thead>";
                for (var i = 0; i < data.length; i++) {
                    html += "<tr>" +
                        "<td>" + (i + 1) + "</td>" +
                        "<td>" + data[i].Name + "</td>" +
                        "<td>";
                    var time = data[i].sDateTime;
                    if (time == "1970-01-01 00:00:00" && data[i].IO == "OUT") {
                        html += "<span style='color:red'>OUT</span>";
                    }
                    else {
                        if (getvalue("acCompanys")[0].TimeFormat == "1") {
                            time = time.substr(0, time.length - 8) + get24Time(time.substr(time.length - 8, 8));
                        }
                        if (data[i].IO == "IN") {
                            html += "<span style='color:green'>" + data[i].IO + " " + time + "</span>";
                        }
                        else {
                            html += "<span style='color:red'>" + data[i].IO + " " + time + "</span>";
                        } //'' + ac[i].Name + '<span class="ui-li-count">[' + ac[i].IO + '] ' + ac[i].sDateTime + '</span></li>';
                    }
                    html += "</td></tr>";
                }
                $("#tblWhoIsIn").html(html);
            }
        });
    };
    return mWhoisin;
})();
$(function () {
    mWhoisin.init();
});
//# sourceMappingURL=mWhoisin.js.map