/// <reference path="../web/jquery/jquery.d.ts" />
/// <reference path="../web/bootstrap3.3.5/js/bootstrap-2.1.d.ts" />
/// <reference path="sShare.ts" />
var clockId = "0";
var username = "";
var password = "";
var aEmployees;
var startDate = "";
var endDate = "";
var barcodeHtml = "";
var native = "";
var sUrl = ""; // window.localStorage.getItem('sUrl');
var isBarcode = false;
var latitude = ""; //经纬度定义。。。。
var longitude = "";
var latitudeZone = ""; //经纬度定义。。。。
var longitudeZone = "";
var u = navigator.userAgent;
var sTempBarcode = "";
var sAddress = "";
var sBarcode = (function () {
    function sBarcode() {
    }
    sBarcode.init = function () {
        window.localStorage.setItem('sUrl', 'https://www.timeclockfree.com/mobile/'); //;
        sUrl = window.localStorage.getItem('sUrl');
        if (native.indexOf("http") == -1) {
            if (window.localStorage.getItem('useExternalScanner') == null || window.localStorage.getItem('useExternalScanner') == "null") {
                window.localStorage.setItem('useExternalScanner', '1');
            }
            if (window.localStorage.getItem('continuouslyScan') == null || window.localStorage.getItem('continuouslyScan') == "null") {
                window.localStorage.setItem('continuouslyScan', '0');
            }
            if (window.localStorage.getItem('useExternalScanner') == "1") {
                $("#cbxUseExternalScanner").prop('checked', 'checked');
                if (window.localStorage.getItem('continuouslyScan') == "1") {
                    $("#cbxContinuouslyScan").prop('checked', 'checked');
                }
            }
        }
        else {
            window.localStorage.setItem('useExternalScanner', '0');
            window.localStorage.setItem('continuouslyScan', '0');
        }
        $("#divUseExternalScanner").hide();
        $("#divComtinuouslyScan").hide();
        if (window.localStorage.getItem('clockId') != "null" && window.localStorage.getItem('clockId') != null && window.localStorage.getItem('clockId') != "") {
            clockId = window.localStorage.getItem('clockId');
            $("#lblClockId").html(clockId);
            sBarcode.sGetBarcodeCookieInfo();
        }
        else {
            sBarcode.getClockId();
        }
        sBarcode.getIp();
    };
    sBarcode.getIp = function () {
        $.post(sUrl + "back/sGetIp.php", "", function (data) {
            var ip = JSON.parse(data);
            $("#lblIP").html("IP: " + ip);
        });
    };
    sBarcode.txtScanBarcode_keyup = function (event) {
        var scanBarcode = $("#txtScanBarcode").val();
        if (scanBarcode.length == 1) {
            startDate = sBarcode.nowTime();
        }
        if (event.keyCode == 13) {
            if (scanBarcode.length == 0) {
                $("#txtScanBarcode").val("");
                return;
            }
            endDate = sBarcode.nowTime();
            if ((string2date(endDate).getTime() - string2date(startDate).getTime()) <= 500) {
                if ($("#spanLoading").val() == "loading ......") {
                    $("#txtScanBarcode").val("");
                    return;
                }
                $("#spanLoading").attr("style", "font-size:30px;margin-left:20px;color:#fa8609;");
                $("#spanLoading").html("loading ......");
                $("#btnScanBarcode").html("loading ...");
                sTempBarcode = $("#txtScanBarcode").val();
                $("#txtScanBarcode").val("");
                sBarcode.clockInOut();
            }
            else {
                $("#txtScanBarcode").val("");
            }
        }
    };
    sBarcode.getGps = function () {
        navigator.geolocation.getCurrentPosition(sBarcode.onGpsSuccess, sBarcode.onGpsError, { maximumAge: 300000, timeout: 5000, enableHighAccuracy: true });
    };
    sBarcode.onGpsError = function (error) {
        setTimeout(function () {
            sBarcode.getGps();
        }, 5000);
    };
    sBarcode.onGpsSuccess = function (position) {
        if (parseFloat(position.coords.latitude).toFixed(2) == latitudeZone && parseFloat(position.coords.longitude).toFixed(2) == longitudeZone) {
            //$("#lblGPS").html("<span>GPS: " + sAddress + " (" + latitudeZone + " ," + longitudeZone + ")</span>");
            return;
        }
        latitudeZone = parseFloat(position.coords.latitude).toFixed(2);
        longitudeZone = parseFloat(position.coords.longitude).toFixed(2);
        if (latitudeZone == "" || longitudeZone == "") {
            setTimeout(function () {
                sBarcode.getGps();
            }, 5000);
            return;
        }
        latitude = parseFloat(position.coords.latitude).toFixed(4);
        longitude = parseFloat(position.coords.longitude).toFixed(4);
        $("#lblGPS").html("<a href='#' onclick='sBarcode.getAddress()'>GPS: (lat " + latitudeZone + ", lon " + longitudeZone + ")</a><br/>");
        setTimeout(sBarcode.getGps, 300000);
    };
    sBarcode.getAddress = function () {
        $.post(sUrl + "back/sGetAddress1.php", { "latitude": latitudeZone, "longitude": longitudeZone }, function (data) {
            sAddress = JSON.parse(data);
            $("#lblGPS").html("GPS: " + sAddress + " (" + latitudeZone + ", " + longitudeZone + ")");
        });
    };
    sBarcode.clockInOut = function () {
        var tempsBarcode = sTempBarcode;
        username = window.localStorage.getItem('barcodeUserName');
        password = window.localStorage.getItem('barcodePassword');
        clockId = window.localStorage.getItem('clockId');
        $.post(sUrl + "back/sClockInOut.php", { "username": username, "password": password, "clockId": clockId, "scanBarcode": tempsBarcode, "Latitude": latitude, "Longitude": longitude }, function (data) {
            $("#btnScanBarcode").html("scan barcode here ...");
            $("#btnScanBarcode").removeClass("disabled");
            data = JSON.parse(data);
            if (data == "ERROR") {
                $("#spanLoading").attr("style", "font-size:30px;margin-left:20px;color:red;");
                $("#spanLoading").html("barcode " + sTempBarcode + " not found");
            }
            else {
                var dateTime = data[0]["DateTime"];
                var timeAmPm = time2ampm(dateTime.substr(11, 5)).toLocaleLowerCase();
                var timeDate = dateTime.substr(5, 5);
                var loadHtml = data[0]["Name"] + "&nbsp;&nbsp;";
                if (data[0]["IO"] == "IN") {
                    loadHtml += "<span style='color:#03ff00;'>IN</span>";
                }
                else {
                    loadHtml += "<span style='color:red;'>OUT</span>";
                }
                loadHtml += "&nbsp;&nbsp;<span style='color:#808080;'>" + timeDate + " " + timeAmPm + "</span> ";
                $("#spanLoading").attr("style", "font-size:30px;margin-left:20px;");
                $("#spanLoading").html(loadHtml);
                var html = "<span>" + data[0]["Name"] + "</span>&nbsp;&nbsp;";
                if (data[0]["IO"] == "IN") {
                    html += "<span style='color:#03ff00;'>&nbsp;&nbsp;IN&nbsp;&nbsp;</span>";
                }
                else {
                    html += "<span style='color:red;'>OUT</span>";
                }
                html += "&nbsp;&nbsp;<span style='color:#808080;'>" + timeDate + " " + timeAmPm + "</span> <br/>";
                barcodeHtml = html + barcodeHtml;
                $("#divBarcode").html(barcodeHtml);
                $("#divCorrect").show();
                setTimeout(function () {
                    $("#divCorrect").hide();
                    if (window.localStorage.getItem('continuouslyScan') == "1") {
                        sBarcode.go();
                    }
                }, 2000);
            }
        });
    };
    sBarcode.sGetBarcodeCookieInfo = function () {
        $.post(sUrl + "back/sGetBarcodeCookieInfo.php", { "clockId": clockId }, function (data) {
            data = JSON.parse(data);
            window.localStorage.setItem("barcodeUserName", data[0].CookieBarcodeUserName);
            window.localStorage.setItem("barcodePassword", data[0].CookieBarcodePassword);
            window.localStorage.setItem("barcodeAutoLogin", data[0].CookieBarcodeAutoLogin);
            if (window.localStorage.getItem('barcodeUserName') != null && window.localStorage.getItem('barcodeUserName') != "" && window.localStorage.getItem('barcodePassword') != null && window.localStorage.getItem('barcodePassword') != "") {
                username = window.localStorage.getItem('barcodeUserName');
                password = window.localStorage.getItem('barcodePassword');
                sBarcode.getUsers();
            }
            else {
                $("#divLoading").attr("style", "display:none;");
                $("#divSetting").attr("style", "margin-left:10px;margin-right:10px;");
                $("#divScan").attr("style", "display:none;");
                if (u.indexOf('iPhone') > -1) {
                    $("#divIporClockId").attr("style", "text-align:left;margin-top:18px;background-color:lightgray;");
                }
                else {
                    $("#divIporClockId").attr("style", "text-align:left;margin-top:0px;background-color:lightgray;");
                }
            }
        });
    };
    sBarcode.getClockId = function () {
        var deviceId = "";
        if (native.indexOf("http") == -1) {
            deviceId = device.uuid;
        }
        $.post(sUrl + "back/sGetClockId.php", { "deviceId": deviceId }, function (data) {
            data = JSON.parse(data);
            clockId = data;
            $("#lblClockId").html(clockId);
            window.localStorage.setItem("clockId", clockId);
            sBarcode.sGetBarcodeCookieInfo();
        });
    };
    sBarcode.getUsers = function () {
        $.post(sUrl + "back/sGetEmployees.php", { "username": username, "password": password, "clockId": clockId }, function (data) {
            data = JSON.parse(data);
            $("#btnLoadData").html("Authorize");
            if (data == "ERROR" || data == "NOTDEVICEID" || data == "BARCODEERROR") {
                if (data == "ERROR") {
                    $("#lblAlert").html("Username or password not matching.");
                }
                else if (data == "NOTDEVICEID") {
                    $("#lblAlert").html('The Device ID ' + clockId + ' is not in your "Permitted Devices" list. Please check with your manager.');
                }
                else {
                    $("#lblAlert").html('Barcode was set to be disable by your manager in "setting"->"company" page.');
                }
                $("#divLoading").attr("style", "display:none;");
                $("#divSetting").attr("style", "margin-left:10px;margin-right:10px;");
                $("#divScan").attr("style", "display:none;");
                if (u.indexOf('iPhone') > -1) {
                    $("#divIporClockId").attr("style", "text-align:left;margin-top:18px;background-color:lightgray;");
                }
                else {
                    $("#divIporClockId").attr("style", "text-align:left;margin-top:0px;background-color:lightgray;");
                }
            }
            else {
                aEmployees = eval(data);
                $("#lblGPS").show();
                if (aEmployees[0]["GpsEnabled"] == "1") {
                    //$("#divGPS").show();
                    $("#lblGPS").html("GPS: na ");
                    sBarcode.getGps();
                }
                else {
                    $("#lblGPS").html("");
                }
                window.localStorage.setItem("barcodeUserName", username);
                window.localStorage.setItem("barcodePassword", password);
                var nowDateTime = data[0]["NowDateTime"];
                var timeAmPm = time2ampm(nowDateTime.substr(11, 5)).toLocaleLowerCase();
                var timeDate = nowDateTime.substr(5, 5);
                var dataLoadHtml = "Device authorized by " + data[0]["Name"];
                dataLoadHtml += "<span style='color:#808080;'> " + timeDate + " " + timeAmPm + "</span>";
                $("#spanLoading").html("");
                $("#spanDateLoad").html(dataLoadHtml);
                $("#divBarcodeFoot").show();
                if (native.indexOf("http") == -1) {
                    $("#divUseExternalScanner").show();
                    $("#divComtinuouslyScan").show();
                    if (window.localStorage.getItem('useExternalScanner') == "1") {
                        $("#cbxUseExternalScanner").prop('checked', true);
                    }
                    else {
                        $("#cbxUseExternalScanner").prop('checked', false);
                    }
                    if (window.localStorage.getItem('continuouslyScan') == "1") {
                        $("#cbxContinuouslyScan").prop('checked', true);
                    }
                    else {
                        $("#cbxContinuouslyScan").prop('checked', false);
                    }
                }
                //alert(window.localStorage.getItem('useExternalScanner'));
                if (window.localStorage.getItem('useExternalScanner') == "1") {
                    $("#txtScanBarcode").attr("style", "display:none;");
                    $("#btnScanBarcode").attr("style", "font-size:30px;line-height:22px;width:100%;height:60px;text-align:center;");
                }
                else {
                    $("#btnScanBarcode").attr("style", "display:none;");
                    $("#txtScanBarcode").attr("style", "font-size:30px;line-height:22px;width:100%;color:#cccccc;text-align:center;");
                }
                $("#divLoading").attr("style", "display:none;");
                $("#divSetting").attr("style", "display:none;");
                $("#divScan").attr("style", "margin-left:10px;margin-right:10px;");
                if (u.indexOf('iPhone') > -1) {
                    $("#divIporClockId").attr("style", "text-align:left;margin-top:18px;background-color:lightgray;");
                }
                else {
                    $("#divIporClockId").attr("style", "text-align:left;margin-top:0px;background-color:lightgray;");
                }
            }
        });
    };
    sBarcode.txtUser_keydown = function (event) {
        if ((event.keyCode == 9) || (event.keyCode == 13)) {
            setTimeout(function () {
                var userName = $("#txtUserName").val().trim();
                if ((userName != "") && (userName != 'username'))
                    $("#txtPassword").focus();
            }, 100);
        }
    };
    sBarcode.txtUser_focusin = function () {
        var user = $("#txtUserName").attr('placeholder'); //$("#txtUserName").val().trim();
        if (user == 'username' && $("#txtUserName").val() == "") {
            $("#txtUserName").val("");
            $("#txtUserName").attr('placeholder', "");
            $("#txtUserName").css("color", "#000000");
        }
        else
            setTimeout(function () { $("#txtUserName").select(); }, 100);
    };
    sBarcode.txtUser_focusout = function () {
        var user = $("#txtUserName").val().trim();
        if (user == "") {
            $("#txtUserName").attr('placeholder', "username");
            $("#txtUserName").css("color", "#CCCCCC");
        }
    };
    sBarcode.txtPassword_focusin = function () {
        var password = $("#txtPassword").attr('placeholder');
        if (password == "password") {
            $("#txtPassword").attr('placeholder', "");
            $("#txtPassword").css("color", "#000000");
        }
    };
    sBarcode.txtPassword_focusout = function () {
        var password = $("#txtPassword").val().trim();
        if (password == "") {
            $("#txtPassword").attr('placeholder', "password");
            $("#txtPassword").css("color", "#CCCCCC");
        }
    };
    sBarcode.lblScanBarCode_click = function () {
        window.location.href = 'barcode.html';
    };
    sBarcode.lblScanBarCode1_click = function () {
        $.post(sUrl + "back/sClearBarcodeCookieInfo.php", { "barcodeUserName": "", "barcodePassword": "", "barcodeAutoLogin": "0", "clockId": clockId }, function (data) {
            data = JSON.parse(data);
            window.localStorage.setItem("barcodeUserName", "");
            window.localStorage.setItem("barcodePassword", "");
            window.localStorage.setItem("barcodeAutoLogin", "0");
            $("#divBarcodeFoot").hide();
            if (native.indexOf("http") == -1) {
                window.localStorage.setItem('useExternalScanner', '1');
                window.localStorage.setItem('continuouslyScan', '0');
                $("#cbxUseExternalScanner").prop('checked', true);
                $("#cbxContinuouslyScan").prop('checked', false);
                $("#divUseExternalScanner").hide();
                $("#divComtinuouslyScan").hide();
            }
            else {
                window.localStorage.setItem('useExternalScanner', '0');
                window.localStorage.setItem('continuouslyScan', '0');
                $("#divUseExternalScanner").hide();
            }
            $("#txtUserName").val('');
            $("#txtUserName").attr('placeholder', "username");
            $("#txtUserName").css("color", "#CCCCCC");
            $("#txtPassword").val("");
            $("#txtPassword").attr('placeholder', "password");
            $("#txtPassword").css("color", "#CCCCCC");
            $("#lblAlert").html("");
            $("#divLoading").attr("style", "display:none;");
            $("#divSetting").attr("style", "margin-left:10px;margin-right:10px;");
            $("#divScan").attr("style", "display:none;");
            $("#lblGPS").hide();
            if (u.indexOf('iPhone') > -1) {
                $("#divIporClockId").attr("style", "text-align:left;margin-top:18px;background-color:lightgray;");
            }
            else {
                $("#divIporClockId").attr("style", "text-align:left;margin-top:0px;background-color:lightgray;");
            }
        });
    };
    sBarcode.txtScanBarcode_focusin = function () {
        var scanBarcode = $("#txtScanBarcode").val().trim();
        if (scanBarcode == 'scan barcode here ...') {
            $("#txtScanBarcode").val("");
            $("#txtScanBarcode").css("color", "#000000");
        }
        else
            setTimeout(function () { $("#txtScanBarcode").select(); }, 100);
    };
    sBarcode.txtScanBarcode_focusout = function () {
        var scanBarcode = $("#txtScanBarcode").val().trim();
        if (scanBarcode == "") {
            $("#txtScanBarcode").val('scan barcode here ...');
            $("#txtScanBarcode").css("color", "#CCCCCC");
        }
    };
    sBarcode.btnLoadData_click = function () {
        username = $("#txtUserName").val();
        password = $("#txtPassword").val();
        if (username == "" || password == "") {
            $("#lblAlert").html("Please input username and password.");
            return;
        }
        $("#btnLoadData").html("loading ...");
        //$("#btnLoadData").attr("disabled", true);
        $("#lblAlert").html("");
        sBarcode.getUsers();
    };
    sBarcode.nowTime = function () {
        var d = new Date();
        return date2string(d);
    };
    sBarcode.cbxUseExternalScanner_click = function () {
        if ($("#cbxUseExternalScanner").prop('checked')) {
            window.localStorage.setItem('useExternalScanner', '1');
            $("#divComtinuouslyScan").show();
            window.localStorage.setItem('continuouslyScan', '0');
        }
        else {
            window.localStorage.setItem('useExternalScanner', '0');
            $("#divComtinuouslyScan").hide();
            window.localStorage.setItem('continuouslyScan', '0');
        }
        if (window.localStorage.getItem('useExternalScanner') == "1") {
            $("#txtScanBarcode").attr("style", "display:none;");
            $("#btnScanBarcode").attr("style", "font-size:30px;line-height:22px;width:100%;height:60px;text-align:center;");
        }
        else {
            $("#btnScanBarcode").attr("style", "display:none;");
            $("#txtScanBarcode").attr("style", "font-size:30px;line-height:22px;width:100%;color:#cccccc;text-align:center;");
        }
    };
    sBarcode.cbxContinuouslyScan_click = function () {
        if ($("#cbxContinuouslyScan").prop('checked'))
            window.localStorage.setItem('continuouslyScan', '1');
        else
            window.localStorage.setItem('continuouslyScan', '0');
    };
    sBarcode.btnScanBarcode_click = function () {
        var disableClass = $("#btnScanBarcode").attr("class");
        if (disableClass.indexOf("disabled") > 0)
            return;
        $("#btnScanBarcode").html("loading ...");
        $("#btnScanBarcode").addClass("disabled");
        sBarcode.go();
    };
    sBarcode.go = function () {
        cordova.plugins.barcodeScanner.scan(function (result) {
            /*
            alert("We got a barcode\n" +
                "Result: " + result.text + "\n" +
                "Format: " + result.format + "\n" +
                "Cancelled: " + result.cancelled);
            */
            if (result.format != "QR_CODE")
                isBarcode = true;
            else
                isBarcode = false;
            if (result.cancelled == false || result.cancelled == 'false') {
                $("#txtScanBarcode").val(result.text);
                sTempBarcode = $("#txtScanBarcode").val();
                sBarcode.clockInOut();
            }
            else {
                alert("Scanning was cancelled");
                $("#btnScanBarcode").html("scan barcode here ...");
                $("#btnScanBarcode").removeClass("disabled");
            }
        }, function (error) {
            alert("Scanning failed: " + error);
        });
    };
    sBarcode.lnkButton_click = function () {
        var action = $(this).val();
        if (action == "reset")
            sBarcode.lblScanBarCode1_click();
        else if (action == "help")
            window.location.href = "contact-us.html";
        else if (action == "back")
            window.location.href = "index.html?logout=true";
        else {
            if (native.indexOf("http") == -1) {
                cordova.InAppBrowser.open('https://www.opentimeclock.com/free.html', '_system', 'location=yes');
            }
            else {
                window.location.href = 'https://www.opentimeclock.com/free.html';
            }
        }
    };
    sBarcode.imgRefresh_click = function () {
        window.location.href = "barcode.html";
    };
    return sBarcode;
})();
function lblGetGps_click() {
    $("#lblGPS").html("loading...");
    sBarcode.getGps();
}
$(function () {
    $("#divBarcodeFoot").hide();
    native = window.location.toString();
    if (native.indexOf("http") == -1) {
        document.addEventListener('deviceready', sBarcode.init, false);
    }
    else {
        var url = window.location.href;
        if (url == "https://timeclockfree.com/mobile/barcode.html" || url == "http://timeclockfree.com/mobile/barcode.html"
            || url == "http://www.timeclockfree.com/mobile/barcode.html") {
            window.location.href = "https://www.timeclockfree.com/mobile/barcode.html";
            return;
        }
        sBarcode.init();
    }
    $("#txtUserName").focusin(sBarcode.txtUser_focusin);
    $("#txtUserName").focusout(sBarcode.txtUser_focusout);
    $("#txtUserName").keydown(sBarcode.txtUser_keydown);
    $("#txtPassword").focusin(sBarcode.txtPassword_focusin);
    $("#txtPassword").focusout(sBarcode.txtPassword_focusout);
    $("#txtScanBarcode").focusin(sBarcode.txtScanBarcode_focusin);
    $("#txtScanBarcode").focusout(sBarcode.txtScanBarcode_focusout);
    $("#txtScanBarcode").keyup(sBarcode.txtScanBarcode_keyup);
    $("#lblScanBarCode").click(sBarcode.lblScanBarCode_click);
    $("#lblScanBarCode1").click(sBarcode.lblScanBarCode1_click);
    $("#btnLoadData").click(sBarcode.btnLoadData_click);
    $("#divBarcodeFoot").on("click", "button", sBarcode.lnkButton_click);
    $("#btnScanBarcode").click(sBarcode.btnScanBarcode_click);
    $("#cbxUseExternalScanner").click(sBarcode.cbxUseExternalScanner_click);
    $("#cbxContinuouslyScan").click(sBarcode.cbxContinuouslyScan_click);
    $("#imgRefresh").click(sBarcode.imgRefresh_click);
    window.onload = function () {
        var oInp = document.getElementById("txtScanBarcode");
        oInp.addEventListener('paste', function (event) {
            event.preventDefault();
        }, false);
    };
});
//# sourceMappingURL=sBarcode.js.map